Ŀ
 Mod Name      : JAFO13A.MOD              Mod Author: JAFO 1@1     TerraNET 
 Difficulty    : ۱                                1@8861  WWIVnet  
 WWIV Version  : 4.23                                      1@8857  IceNET   
 Mod Date      : 12/01/93                                  1@8857  SOLARnet 
 Files Affected: EXTRN.C, FCNS.H, MAKEFILE.MAK             1@18857 WWIVLink 
 Description   : Swap BBS to EMS/Disk for Upload Event                      


[ Description ]

This modification uses the XSPAWN library of routines to give WWIV the ability
to swap out to EMS/disk for the upload event.  This will allow you to run
almost any upload event checker with no problems!

WARNING:  I have tested this modification here on Blue Thunder, and it SEEMS
          to work fine.  If however, it causes your system to blow up, please
          remember this warning.  You are installing this modification at YOUR
          own risk.  I cannot guarantee anything.  I believe this modification
          is of good quality, but again, nothing is guaranteed.

          Also, this modification requires the use of TASM (Turbo Assembler).
          If you don't have this program, you cannot use this mod.  Sorry.

NOTICE:   XSPAWN is copyrighted by Whitney Software, Inc.  Please read the
          documentation in XSPAWN34.ZIP for more information about it.

Revision A Note:  This modification has been updated for WWIV v4.23.  There
                  are also bug fixes that fix most of the problems encountered
                  in the original mod (memory problems).  Again, if it still
                  doesn't work for you, there is nothing I can do.

                  If you are upgrading from the original mod, you should
                  re-install the ENTIRE modification.

[ Legend ]

  =  Existing line - Do not change
  +  Add this line
  -  Delete this line

[ Step 1 ]

Please back up your source code.  Even the best programmers make mistakes.

[ Step 2 ]

In EXTRN.C, add the following line.

= #include "vars.h"
+ #include "xspawn.h"
+
= #pragma hdrstop

[ Step 3 ]

Now, add the following function right after "int do_it".

int do_it_ul(char *cl)
{
  int i,i1,l;
  char s[160];
  char *ss[30];

  sl1(1,"");
  strcpy(s,cl);
  ss[0]=s;
  i=1;
  l=strlen(s);
  for (i1=1; i1<l; i1++)
    if (s[i1]==32) {
      s[i1]=0;
      ss[i++]=&(s[i1+1]);
    }
  ss[i]=NULL;
  funcs[20]=NULL;
  if ((_swappath=malloca(strlen(syscfgovr.tempdir)+1))==NULL)
    return(0);
  strcpy(_swappath,syscfgovr.tempdir);
  _swappath[strlen(syscfgovr.tempdir)-1]=0;
  addvect(INT_REAL_DOS,CURRENT);
  addvect(0x22,CURRENT);
  addvect(0x24,CURRENT);
  addvect(0x2e,CURRENT);
  addvect(0x2f,CURRENT);
  addvect(0xea,CURRENT);
  addvect(0xfe,CURRENT);
  setvect(save_dos,NULL);
  set_protect(0);
  if (base)
    outportb(base+1,0);
  i=xspawnvpe(P_WAIT,ss[0],ss,xenviron);
  if (base)
    outportb(base+1,1);
  funcs[20]=NULL;
  setvect(save_dos,getvect(INT_REAL_DOS));
  farfree(_swappath);
  return(i);
}

[ Step 4 ]

Replace "int do_remote" with the function below:

int do_remote(char *s, int ccc)
{
  int rc,i;
  char x[161];

  sl1(1,"");

  if ((ccc==2) && (ok_modem_stuff))
    closeport();

  if (useron) {
    write_user(usernum,&thisuser);
    write_qscn(usernum,qsc,0);
  }
  close_strfiles();
  if (!checking_event) {
    checkhangup();
    if (hangup)
      return(32767);
  }
  sprintf(x,"%s /C %s", getenv("COMSPEC"), s);
  switch (ccc) {
    case 0:
      rc=do_it(s);
      break;
    case 1:
      rc=do_it(x);
      break;
    case 2:
      rc=do_it_ul(x);
      break;
  }
  if (ccc==2)
    initport(syscfgovr.primaryport);
  else
    initporte(syscfgovr.primaryport);
  chdir(cdir);
  setdisk(cdir[0]-'A');
  if (useron) {
    i=useron;
    useron=0;
    read_user(usernum,&thisuser);
    read_qscn(usernum,qsc,0);
    useron=i;
  }
  return(rc);
}

[ Step 5 ]

In "int run_external_ul", change the line indicated.

= int run_external_ul(char *s)
= {
=   int i;
=
=   checking_event=1;
-   i=do_remote(s,1);
+   i=do_remote(s,2);
=   checking_event=0;
=   return(i);
= }

[ Step 6 ]

In FCNS.H, add the lines shown below:

= /* File: extrn.c */
=
= unsigned char getkeyext(void);
= void cd_to(char *s);
= void get_dir(char *s, int be);
= void initporte(int port_num);
= int do_it(char *cl);
+ int do_it_ul(char *cl);
= int do_remote(char *s, int ccc);

[ Step 7 ]

Now, we need to link BBS.EXE with XSPAWN's XSPNTPPL.LIB library file.  To do
this, we have to modify MAKEFILE.MAK.  If you use a project file, simply
add XSPNTPPL.LIB to your project file, and skip Step 7 and 8.  Step 7 is for
users of TC++ ONLY.  If you use BC++, skip to Step 8.  Also note that I use
BC++, so if this step doesn't work, please let me know!

First, search for the following section in MAKEFILE.MAK, and add "xspntppl"
on the last line.

$(EXE)bbs.exe: $(BBS_NRM) $(BBS_OVL) version.c
  $(TCC_VER)
  tlink /c /x @&&^
$(TC)\lib\c0l.obj $(OBJ)version.obj $(BBS_NRM) $(OVER_START) $(BBS_OVL) $(OVER_END)
$(EXE)bbs
bbs.map
xspntppl $(TC)\lib\$(LIB87) $(TC)\lib\mathl $(OVER_LIB) $(TC)\lib\cl

Second, search for the following section, and add "xspntppl+" to the last
line.

$(EXE)bbs.exe: $(BBS_NRM) $(BBS_OVL) linkfile version.c
  $(TCC_VER)
  tlink /c /x @linkfile,$(EXE)bbs,bbs.map,xspntppl+$(TC)\lib\$(LIB87)+$(TC)\lib\mathl+$(TC)\lib\cl

[ Step 8 ]

This step is for BC++ users only.  We need to modify MAKEFILE.MAK to link
the library in, as stated in Step 5.  So, search for the following section
and add "xspntppl" to the last line.

bbs.exe: $(BBS_NRM) $(BBS_OVL) version.c
  $(TCC_VER)
  tlink /c /x @&&^
  c0l $(OBJ)\version.obj $(BBS_O_NRM) $(OVER_START) $(BBS_O_OVL) $(OVER_END)
$*
nul
xspntppl $(LIB87) mathl $(OVER_LIB) cl

[ Step 9 ]

Now you must create the XSPAWN library file.  Create a temporary directory,
and unzip XSPAWN34.ZIP into it.  Run the XTCPP.BAT file.  If you are using
BC++ you need to change the line in that batch file that calls "tcc" to "bcc".
Once it has finished, copy the XSPNTPPL.LIB and XSPAWN.H files into your
source directory.

NOTE:  Borland C++ 3.1 (and possibly TC++ 3.0) users will notice that when
       running the XTCPP.BAT file, you will see a bunch of warnings that
       say "Initialization is only partially bracketed".  This should not
       affect the way this modification works.  It is just the compiler
       being picky.  Note that Borland C++ 2.0 does not report these
       warnings.

[ Step 10 ]

Compile your source.

[ Disclaimer ]

Don't complain to me if your board gets fried, your hard disk goes nuts, or
something terrible happens.  The code in this mod should be harmless, but I
can't guarantee it will work for you.  It works on my board.

JAFO 1@1     TerraNET
     1@8861  WWIVnet
     1@8857  IceNET
     1@8857  SOLARnet
     1@18857 WWIVLink
