TFC005.MOD - Enhanced time display
Author: The Flying Chicken 1@12456 (WWIVLink)
Source: WWIV 4.20

    After staring at the "01:50:30" time display for ages, I got real tired
    of it, and decided it would be easy to make it more meaningful.  Well,
    that's exactly what this mod does.  Many users don't understand what
    "01:50:30" means, but they do understand "1 hour, 50 minutes, 30 seconds".
    I also have included Goose's enhanced time display mod, mainly becuase
    it is a mod that should be included in the source code anyway.  That mod
    changes "Sun, Apr 1 14:28:12 1990" to the more readable format,
    "Sunday, April 1, 1990   2:28 pm" (not to mention that it puts the year
    with the rest of the date!).  Many thanks and all the credit goes to Goose
    for his time display mod, which gave me the idea and basis for the total
    mod I have here.  By the way, I also had both of these mods in my
    4.12 source, so they are downward compatable, you just have to find
    the right source file to make the changes in.

    Before using this or any mod, back up your source !!!!!

                PKZIP source *.c *.h *.mak

    1. Load up FCNS.H and add the following line as shown.

int lcs();
void checka(int *abort, int *next);
void pla(char *s, int *abort);
char *ctim(double d);
char *ctim2(double d);                              /* ADD */
int sysop2();


    2. Search down farther and make the changes shown.

char *date();
char *times();
char *atime();                                             /* ADD */
unsigned int finduser(char *s);
void changedsl();

    3. Save FCNS.H and load BBSUTL.C.  Add the following procedure,
       right after char *ctim().

char *ctim2(double d)                               /* ADD FUNCTION */
{
  static char ch2[81];
  char ht[20],mt[20],st[20];
  long h,m,s;

  h=(long) (d/3600.0);
  d-=(double) (h*3600);
  m=(long) (d/60.0);
  d-=(double) (m*60);
  s=(long) (d);
  if (h==0)
    strcpy(ht,"");
  else 
        sprintf(ht,"[34m%ld [36m%s",h,(h>1)?"hours":"hour");[37m
  if (m==0)
    strcpy(mt,"");
  else
        sprintf(mt,"[34m%ld [36m%s",m,(m>1)?"minutes":"minute");[37m
  if (s==0)
    strcpy(st,"");
  else
        sprintf(st,"[34m%ld [36m%s",s,(s>1)?"seconds":"second");[37m

  if (h==0) {
        if (m==0) {
          if (s==0) {
                strcpy(ch2," ");
          } else {
                strcpy(ch2,st);
          }
        } else {
          strcpy(ch2,mt);
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        }
  } else {
        strcpy(ch2,ht);
        if (m==0) {
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        } else {
          strcat(ch2,", ");
          strcat(ch2,mt);
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        }
  }
  return(ch2);
}


    4. Save BBSUTL.C and load up XFER.C.  Search for the int printfileinfo()
       procedure and make the changes shown.

  npr("Filename   : %s\r\n", stripfn(u->filename));
  npr("Description: %s\r\n", u->description);
  npr("File size  : %dk\r\n", ((u->numbytes)+1023)/1024);
  npr("Apprx. time: %s\r\n", ctim2(d));                 /* CHANGE (Add '2') */
  npr("Uploaded on: %s\r\n", u->date);


    5. Save XFER.C and load up BATCH.C.  Search for void listbatch()
       and make the changes shown.

  abort=0;
  nl();
  if (numbatchdl)
    npr("Files - %d  Time - %s\r\n",numbatch,ctim2(batchtime)); /* CHANGE */
  else
    npr("Files - %d\r\n",numbatch);
  nl();


    6. Now search for void ymbatchdl() and make the changes shown.

  if (!incom)
    return;
  sprintf(s,"Ymodem BATCH DL, %d files, time=%s",numbatchdl, ctim2(batchtime));
  if (had)                                        /* CHANGE ABOVE LINE */
    strcat(s,", HAD");


    7. Scroll down further and continue.

      if (i<=0) {
        delbatch(cur);
        closedl();
      } else {
        sprintf(s,"%d files left, Time left = %s\r\n",numbatchdl,ctim2(batchtim
e));
        outs(s);                                        /* CHANGE ABOVE LINE */
        SETREC(i);


    8. Now search for void dszbatchdl() and make the changes.

  sprintf(dl,"%s BATCH DL, %d files, time=%s",
          desc, numbatchdl, ctim2(batchtime));          /* CHANGE */
  if (had)
    strcat(dl,", HAD");
  sysoplog(dl);
  nl();
  pl(dl);


    9. Save BATCH.C and load BBS.C.  Search for void mainmenu() and
       make the changes shown.  Note that most modders change this
       part of the code, you just need to change ctim() to ctim2().

  if ((sysstatus_expert & thisuser.sysstatus)==0)
    printmenu(0);
  nl();
  nl();
  tleft(1);
  npr("T - %s\r\n",ctim2(nsl()));               /* CHANGE */
  s1[0]=0;


    10. Search down further and continue.

        if (yn()) {
          outchr(12);
          npr("Time on   = %s\r\n",ctim2(timer()-timeon));  /* CHANGE */
          printfile("LOGOFF");
          hangup=1;
        }
        break;


    11. Now in void dlmainmenu() make the changes shown.

  nl();
  nl();
  tleft(1);
  npr("T - %s\r\n",ctim2(nsl()));                   /* CHANGE */
  s1[0]=0;
  if (udir[curdir].subnum==-1) {


    12. Scroll down further and continue.

        if (yn()) {
          outchr(12);
          npr("Time on   = %s\r\n",ctim2(timer()-timeon));  /* CHANGE */
          printfile("LOGOFF");
          hangup=1;
        }
        break;


    13. Save BBS.C and load SR.C.  Search for void send_file() and make
        the changes.  Note that the line changed was too long for the
        editor, so I moved it down so you could see it.

              pl("File added to batch queue.");
              sprintf(s,"Batch: Files - %d  Time - %s",numbatch,
                        ctim2(batchtime));      /* CHANGE */
              nl();
              pl(s);
              nl();
              *sent=0;


    14. Save SR.C and load COM.C.  Search for void ptime() and replace
        it with the function below.

void ptime()                            /* REPLACE ENTIRE FUNCTION */
{
  char xl[81], cl[81], atr[81], cc, s[81];
  long l;

  savel(cl, atr, xl, &cc);

  ansic(0);
  nl();
  nl();
  strcpy(s,atime());
  pl(s);
  if (useron) {
    npr("[0;34;40mTime on   = %s\r\n", ctim2(timer() - timeon));[0;37;40;1m
    npr("[0;34;40mTime left = %s\r\n", ctim2(nsl()));[0;37;40;1m
  }
  nl();

  restorel(cl, atr, xl, &cc);
}


    15. Save COM.C and load BBSUTL.C.  Search for char *ctim() and
        add the following function right after it.

char *ctim2(double d)                       /* ADD ENTIRE FUNCTION */
{
  static char ch2[81];
  char ht[20],mt[20],st[20];
  long h,m,s;

  h=(long) (d/3600.0);
  d-=(double) (h*3600);
  m=(long) (d/60.0);
  d-=(double) (m*60);
  s=(long) (d);
  if (h==0)
    strcpy(ht,"");
  else 
        sprintf(ht,"[34m%ld [36m%s",h,(h>1)?"hours":"hour");[37m
  if (m==0)
    strcpy(mt,"");
  else
        sprintf(mt,"[34m%ld [36m%s",m,(m>1)?"minutes":"minute");[37m
  if (s==0)
    strcpy(st,"");
  else
        sprintf(st,"[34m%ld [36m%s",s,(s>1)?"seconds":"second");[37m

  if (h==0) {
        if (m==0) {
          if (s==0) {
                strcpy(ch2," ");
          } else {
                strcpy(ch2,st);
          }
        } else {
          strcpy(ch2,mt);
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        }
  } else {
        strcpy(ch2,ht);
        if (m==0) {
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        } else {
          strcat(ch2,", ");
          strcat(ch2,mt);
          if (s!=0) {
                strcat(ch2,", ");
                strcat(ch2,st);
          }
        }
  }
  return(ch2);
}


    16. Save BBSUTL.C and load XFERTMP.C.  Search for the
        void download_temp_arc() and make the changes shown.

  if (d<=nsl()) {
    npr("Approx. time: %s\r\n",ctim2(d));               /* CHANGE */
    sent=0;
    abort=0;
    sprintf(s,"TEMP.%s",syscfg.arcs[ARC_NUMBER].extension);
    send_file(s1,&sent,&abort,0,s,-1,numbytes);


    17. Save XFERTMP.C and load UTILITY.C.  Search for
        unsigned int finduser() and add the following function
        right before it.

char *atime()                                   /* ADD ENTIRE FUNCTION */
{
        static char dt[81];
        char dow[10],mon[10],ap[10];
        int i,d,y;
        union REGS r;

        r.h.ah = 0x2a;
        r.h.al = 0;
        int86(0x21, &r, &r);
        switch (r.h.al) {
          case 0 : strcpy(dow,"Sunday");        break;
          case 1 : strcpy(dow,"Monday");        break;
          case 2 : strcpy(dow,"Tuesday");       break;
          case 3 : strcpy(dow,"Wednesday");     break;
          case 4 : strcpy(dow,"Thursday");      break;
          case 5 : strcpy(dow,"Friday");        break;
          case 6 : strcpy(dow,"Saturday");      break;
        }
        switch (r.h.dh) {
          case 1 : strcpy(mon,"January");       break;
          case 2 : strcpy(mon,"February");      break;
          case 3 : strcpy(mon,"March");         break;
          case 4 : strcpy(mon,"April");         break;
          case 5 : strcpy(mon,"May");           break;
          case 6 : strcpy(mon,"June");          break;
          case 7 : strcpy(mon,"July");          break;
          case 8 : strcpy(mon,"August");        break;
          case 9 : strcpy(mon,"September");     break;
         case 10 : strcpy(mon,"October");        break;
         case 11 : strcpy(mon,"November");  break;
         case 12 : strcpy(mon,"December");       break;
        }
        d=r.h.dl;
        y=r.x.cx;
        r.h.ah = 0x2c;
        r.h.al = 0;
        int86(0x21, &r, &r);
        i=r.h.ch;
        if (i>12)
          i-=12;
        if (i==0)
          i=12;
        if (r.h.ch<12)
          strcpy(ap,"am");
        else
          strcpy(ap,"pm");
        sprintf(dt,"[36m%s, %s %d, %4d  [0;34;40m%2d:%02d %s",dow,mon,d,y,i,r.h.cl,ap);[0;37;40;1m
        return(dt);
}


    18. Save UTILITY.C and load MSGBASE.C.  Search for void inmsg()
        scroll down some, and make the changes shown.

    if (real_name)
      addline(b,thisuser.realname,&l1);
    else
      addline(b,nam1(&thisuser,usernum,syscfg.systemnumber),&l1);
    time(&ll);                          /* DELETE THIS LINE */
    strcpy(s,ctime(&ll));               /* DELETE THIS LINE */
    s[strlen(s)-1]=0;                   /* DELETE THIS LINE */
    strcpy(s,atime());                  /* ADD THIS LINE */
    addline(b,s,&l1);


    19. Save MSGBASE.C.


    Well, that's it.  Easy huh.  Compile the code, and yer off!

    As usual, I don't make any claims with this mod, I am simply
    releasing it to help you out.  I will NOT be responsible for
    anything other than good results.

    It is not my fault if this mod doesn't work, however if you
    can explain in detail the problem you are having, I will try
    to help you correct it.  Make sure you notify me so I can
    correct the mod in future releases.

    It is defintely not my fault if you install this mod, it doesn't
    work, and you didn't back up your source.  Your just sh*t out
    of luck.

    If you use this mod, drop me a note and tell me how wonderful
    you are, and if you feel like it, how wonderful I am.  But
    drop me a note.

    If you have any ideas for new mods, or would like some more
    information about this one, please e-mail me at the following
    address.


                   The Flying Chicken  1@12456 (WWIV Link)
                            The Insane Asylum BBS
