Ŀ
 Mod Name      : JAFO14A.MOD              Mod Author: JAFO 1@1     TerraNET 
 Difficulty    : ۱                                1@8857  IceNET   
 WWIV Version  : 4.22                                      1@8861  WWIVnet  
 Mod Date      : 03/07/93                                  1@18868 WWIVLink 
 Files Affected: BATCH.C, BBS.C, DIREDIT.C, XFER.C, XFERTMP.C, XINIT.C      
                 FCNS.H, VARS.H                                             
 Description   : The Multiple UL/DL Ratios Mod                              


[ Description ]

This modification will enable you to set up different upload/download ratios
for each directory on your system.  You can even give directories a ratio of
0.000, which would mean they are free.  So if you are using JAFO10, my Free
Download Directories mod, then you should remove it.

Revision A Note:  Fixed a MAJOR bug!  The original mod effectively made all
                  non-free dirs free and made free dirs non-free!  This was
                  all because a simple '!' was misplaced.  SORRY.

                  The other major change is that batch downloads will now
                  work fine in ratio free directories.

[ Legend ]

  =  Existing line - Do not change
  +  Add this line
  -  Remove this line

[ Step 1 ]

Please back up your source code.  Even the best programmers make mistakes.

[ Step 2 ]

In BATCH.C, make the following changes in "void downloaded".

= void downloaded(char *fn, long cps)
= {
=   int i,i1;
=   uploadsrec u;
=   char s[81];
=
=   for (i1=0; i1<numbatch; i1++) {
=     if ((strcmp(fn,batch[i1].filename)==0) && (batch[i1].sending)) {
=       dliscan1(batch[i1].dir);
=       i=recno((batch[i1].filename));
=       if (i>0) {
=         SETREC(i);
=         read(dlf,(void *)&u,sizeof(uploadsrec));
-         ++thisuser.downloaded;
-         thisuser.dk += (int) ((u.numbytes+1023)/1024);
+         if (dir_ratios[batch[i1].dir]) {
+           ++thisuser.downloaded;
+           thisuser.dk += (int) ((u.numbytes+1023)/1024);
+         }
=         ++u.numdloads;
=         SETREC(i);

[ Step 3 ]

In "void ymbatchdl", make the following changes.

=   rr=0;
=   do {
=     tleft(1);
-     if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
+     if ((dir_ratios[batch[cur].dir]>0.0001) &&
+         (ratio()<dir_ratios[batch[cur].dir]))
=       rr=1;
=     if (thisuser.exempt & exempt_ratio)
=       rr=0;

[ Step 4 ]

In "void make_dl_batch_list", make the following changes.

=       if (nsl() < (batch[i].time + at))
=         ok=0;
=       thisk=(batch[i].len+1023)/1024;
-       if ((syscfg.req_ratio>0.0001) && (ratio1(addk+thisk)<syscfg.req_ratio)
-           && (!(thisuser.exempt & exempt_ratio)))
+       if ((dir_ratios[batch[i].dir]>0.0001) &&
+           (ratio1(addk+thisk)<dir_ratios[batch[i].dir]) &&
+           (!(thisuser.exempt & exempt_ratio)))
=         ok=0;
=       if (ok) {

[ Step 5 ]

In "void batchdl", make the following change.

=       case 'D':
=         if (numbatchdl==0) {
=           nl();
=           pl(get_string(882));
=           nl();
=           break;
=         }
=
=         nl();
-         if (!ratio_ok()) {
+         if (!ratio_ok(max_dirs)) {
=           nl();
=           pl(get_string(883));
=           nl();
=           break;
=         }

[ Step 6 ]

In BBS.C, add the following lines to "void dlmainmenu".

=       case 'G':
=         helpl=30;
=         temporary_stuff();
=         break;
+       case 'I':
+         nl();
+         npr("The up/download ratio for the current directory is %-5.3f.",
+             dir_ratios[udir[curdir].subnum]);
+         nl();
+         break;
=       case 'L':
=         listfiles();
=         break;

[ Step 7 ]

In DIREDIT.C, add the following line in "void modify_dir".

= void modify_dir(int n)
= {
=   directoryrec r;
=   char s[81],s1[81],ch,ch2,*ss;
=   int i,i1,done;
+   float f;
=
=   r=directories[n];

[ Step 8 ]

Farther down in "void modify_dir", add and change the following lines.

=     outstr(get_string(144));
=     pl((r.mask & mask_archive) ? str_yes : str_no);
+     npr("L. Dir Ratio  : %-5.3f\r\n",dir_ratios[n]);
=     nl();
-     prt(2,get_string(119));
-     ch=onek("QABCDEFGHIJK");
+     prt(2,"Which (A-L,Q) ? ");
+     ch=onek("QABCDEFGHIJKL");
=     switch(ch) {

[ Step 9 ]

Still farther down in "void modify_dir", add the following lines.

=       case 'K':
=         r.mask &= ~mask_archive;
=         nl();
=         prt(5,get_string(158));
=         if (yn())
=           r.mask |= mask_archive;
=         break;
+       case 'L':
+         nl();
+         prt(5,"New ratio? ");
+         input(s,5);
+         f=atof(s);
+         if (s[0]) {
+           dir_ratios[n]=f;
+           save_dir_ratios();
+         }
+         break;
=     }
=   } while ((!done) && (!hangup));
=   directories[n]=r;
= }

[ Step 10 ]

In "void insert_dir", add the lines shown.

= void insert_dir(int n)
= {
=   directoryrec r;
=   int i,i1,i2,nu;
=   unsigned long *qsc, *qsc_n, m1, m2, m3;
=
=   for (i=num_dirs-1; i>=n; i--) {
=     directories[i+1]=directories[i];
=     dir_dates[i+1]=dir_dates[i];
+     dir_ratios[i+1]=dir_ratios[i];
=   }
=   strcpy(r.name,get_string(159));
=   strcpy(r.filename,get_string(82));
=   strcpy(r.path,syscfg.dloadsdir);
=   r.dsl=10;
=   r.age=0;
=   r.maxfiles=50;
=   r.dar=0;
=   r.type=0;
=   r.mask=0;
=   directories[n]=r;
=   ++num_dirs;
=
+   dir_ratios[n]=syscfg.req_ratio;
+   save_dir_ratios();
+
=   nu=number_userrecs();
=   close_user();

[ Step 11 ]

In "void delete_dir", add the lines shown.

= void delete_dir(int n)
= {
=   int i,i1,i2,nu;
=   unsigned long *qsc, *qsc_n, m2, m3;
=
=   for (i=n; i<num_dirs; i++) {
=     directories[i]=directories[i+1];
=     dir_dates[i]=dir_dates[i+1];
+     dir_ratios[i]=dir_ratios[i+1];
=   }
=   --num_dirs;
=
+   save_dir_ratios();
+
=   nu=number_userrecs();
=   close_user();

[ Step 12 ]

In XFER.C, change the following lines in "int ratio_ok".

- int ratio_ok(void)
+ int ratio_ok(int dn)
= {
=   int ok=1;
=   char s[101];
=
=   if (!(thisuser.exempt & exempt_ratio))
-     if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio)) {
+     if ((dir_ratios[dn]>0.0001) && (ratio()<dir_ratios[dn])) {
=       ok=0;
=       nl();
=       nl();
=       sprintf(s,"%s %-5.3f.  %s %-5.3f %s.",
=               get_string(730), ratio(),
-               get_string(731), syscfg.req_ratio,
+               get_string(731), dir_ratios[dn],
=               get_string(732));
=       pl(s);
=       nl();
=     }

[ Step 13 ]

Right before "void dliscan1", add the following two functions.

void load_dir_ratios(void)
{
  int f,i;
  char s[81];

  sprintf(s,"%sRATIOS.DAT",syscfg.datadir);
  f=open(s,O_RDONLY | O_BINARY);
  if (f>0) {
    for (i=0; i<num_dirs; i++)
      read(f,&dir_ratios[i],sizeof(float));
    dir_ratios[max_dirs]=syscfg.req_ratio;
    close(f);
  } else {
    f=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
    if (f>0) {
      for (i=0; i<num_dirs; i++) {
        dir_ratios[i]=syscfg.req_ratio;
        write(f,&dir_ratios[i],sizeof(float));
      }
      dir_ratios[max_dirs]=syscfg.req_ratio;
      close(f);
    }
  }
}

void save_dir_ratios(void)
{
  int f,i;
  char s[81];

  sprintf(s,"%sRATIOS.DAT",syscfg.datadir);
  f=open(s,O_RDWR | O_BINARY);
  if (f>0) {
    for (i=0; i<num_dirs; i++)
      write(f,&dir_ratios[i],sizeof(float));
    chsize(f,num_dirs*sizeof(float));
    close(f);
  }
}

[ Step 14 ]

In "int try_to_download", make the following change.

=   ok=1;
=   foundany=1;
=   while ((i>0) && (ok) && (!hangup)) {
-     if (!ratio_ok()) {
+     if (!ratio_ok(dn)) {
=       closedl();
=       return(-1);
=     }
=     tleft(1);

[ Step 15 ]

Still in "int try_to_download", add the following lines.

=         send_file(s1,&sent,&abort,u.filetype,u.filename,dn, u.numbytes);
=       if (sent) {
-         ++thisuser.downloaded;
-         thisuser.dk += (int) ((u.numbytes+1023)/1024);
+         if (dir_ratios[dn]) {
+           ++thisuser.downloaded;
+           thisuser.dk += (int) ((u.numbytes+1023)/1024);
+         }
=         ++u.numdloads;
=         SETREC(i);

[ Step 16 ]

In XFERTMP.C, change the following line in "void download_temp_arc".

= void download_temp_arc(char *fn, int xfer)
= {
=   char s[81],s1[81];
=   long numbytes;
=   double d;
=   int i,f,sent,abort;
=
=   outstr(get_string(847));
=   npr("%s.%s:\r\n\r\n", fn, syscfg.arcs[ARC_NUMBER].extension);
-   if (xfer && !ratio_ok()) {
+   if (xfer && !ratio_ok(max_dirs)) {
=     pl(get_string(848));
=     return;
=   }

[ Step 17 ]

In XINIT.C, add the following lines "void init".

=   num_dirs=(read(i,directories, (max_dirs*sizeof(directoryrec))))/
=            sizeof(directoryrec);
=   close(i);
=
+   dir_ratios=(float *) mallocx((max_dirs+1)*sizeof(float),"dir_ratios");
+   load_dir_ratios();
+
=   chains=(chainfilerec *) mallocx(50 * sizeof(chainfilerec), "chains");
=   numextrn=0;

[ Step 18 ]

In FCNS.H, change the following lines.

= void get_arc_cmd(char *out, char *arcfn, int cmd, char *ofn);
= int list_arc_out(char *fn, char *dir);
- int ratio_ok(void);
+ int ratio_ok(int dn);
= int dcs(void);
+ void load_dir_ratios(void);
+ void save_dir_ratios(void);
= void dliscan1(int dn);
= void dliscan_hash(int dn);

[ Step 19 ]

In VARS.H, change the following line.

= __EXTRN__ unsigned long *qsc, *qsc_n, *qsc_q, *qsc_p;
=
=
- __EXTRN__ float batchtime;
+ __EXTRN__ float batchtime, *dir_ratios;
=
= __EXTRN__ double extratimecall, last_time, timeon, time_event, xtime;

[ Step 20 ]

Compile your source.  We have changed VARS.H so this means the board will need
a full re-compile.

[ Step 21 ]

Load the board and do //DIREDIT.  If you want to create a new free directory,
call it something like "Free Downloads" and give that directory a ratio of
0.000.  By default, all directories have the ratio assigned in INIT.  If you
wish to change them, do so by selecting 'L' while editing a particular dir
and assign it whatever ratio you like.

Also, don't forget to edit your menus to reflect the new 'I' command in
transfers.  This will let users see what the ratio is on a particular dir.

[ Disclaimer ]

Don't complain to me if your board gets fried, your hard disk goes nuts, or
something terrible happens.  The code in this mod should be harmless, but I
can't guarantee it will work for you.  It works on my board.

JAFO 1@1     TerraNET
     1@8857  IceNET
     1@8861  WWIVnet
     1@18868 WWIVLink

          7 1Blue Thunder BBS 7

          1TerraNET @1 7 1IceNET @8857 7 1WWIVnet @8861 7 1WWIVLink @188680

