Ŀ
 Mod Name: SM01A.MOD                     Mod Author: The Sandman 1@8307     
 Difficulty: Simple as hell!             Date: 02/27/93                     
 WWIV Version: WWIV 4.22                                                    
 Description: Makes your user list show user name, last on date, and where  
              they're calling from.                                         


     Revision A: I had a complaint about this mod showing the total number of
users at the bottom instead of showing the total number of users that were
allowed on that sub.  Like, for instance, if you had a sub for visiting sysops
for which 23 out of 279 users had access to, it would list 23 users, and say
"[279 Users!]" at the end of the list.  This fixes that problem.

     I also made a few changes that makes it look a little nicer in my opinion.
The char *nam2(userrec *u1) isn't my code, although I have included it here in
this mod because you will need it for this revision.

        I got the idea to write this mod from someone else who wrote one
    like this for WWIV v4.21a and previous versions.  I wrote mine to look
    better, be more colorful, and to show the City, State correctly for
    WWIV v4.22.

[Step 1]   Back up your source code.  There really is no need to because this
           is just a void replacement, but go ahead and do it anyway!  You
           need to get in the good habit of doing it <g>.

[Step 2]   Load up MISCCMD.C and search for void list_users(void);

[Step 3]   Replace your whole void list_users(void); with this one:

void list_users(void)
{
  subboardrec s;
  userrec u;
  int i,nu,abort,ok,num;
  char st[81],s1[121],s2[121],s3[81],s4[81],z[100];

  abort=0;
  num=0;

  if (usub[cursub].subnum==-1) {
    nl();
    pl("No sub!");
    nl();
    return;
  }
  s=subboards[usub[cursub].subnum];
  nl();
  pl("[Users with access to the current sub]");     
  ansic(7);
  outchr(218);
  for (i=0; i<6; i++)
  outchr(196);
  outchr(194);
  for (i=0; i<24; i++)
  outchr(196);
  outchr(194);
  for (i=0; i<7; i++)
  outchr(196);
  outchr(194);
  for (i=0; i<22; i++)
  outchr(196);
  outchr(191);
  nl();
  sprintf(s2,"User # %-23.23s %-5.5s  %-20.20s ",
  "Users",
  "LstOn","City, State");
  pla(s2, &abort);
  ansic(7);
  outchr(195);
  for (i=0; i<6; i++)
  outchr(196);
  outchr(197);
  for (i=0; i<24; i++)
  outchr(196);
  outchr(197);
  for (i=0; i<7; i++)
  outchr(196);
  outchr(197);
  for (i=0; i<22; i++)
  outchr(196);
  outchr(180);
  nl();
  for (i=0; (i<status.users) && (!abort) && (!hangup); i++) {
    read_user(smallist[i].number,&u);
    ok=1;
    if (u.sl<s.readsl)
      ok=0;
    if (u.age<(s.age&0x7f))
      ok=0;
    if ((s.ar!=0) && ((u.ar & s.ar)==0))
      ok=0;
    if (ok) {
      strcpy(s4,u.city);
      strcat(s4,", ");
      strcat(s4,u.state);
      sprintf(s2,"%5d  %-23.23s %-5.5s  %-20.20s ",
      smallist[i].number,
      nam2(&u),
      u.laston, s4);
      pla(s2, &abort);
      ++num;
    }
  }
  if (!abort) {
    itoa(num,st,10);
    ansic(7);
  outchr(192);
  for (i=0; i<6; i++)
  outchr(196);
  outchr(193);
  for (i=0; i<24; i++)
  outchr(196);
  outchr(193);
  for (i=0; i<7; i++)
  outchr(196);
  outchr(193);
  for (i=0; i<22; i++)
  outchr(196);
  outchr(217);
    nl(); nl();
    npr("[%d Users!]",num);  /* SM01A */
    nl();
  }
}

[Save MISCCMD.C]

[Step 4]   Open utility.c and add this right after char *nam1

char *nam2(userrec *u1)
 {
   static char o[81];
   int f,p;
   userrec u;

   u=*u1;
   f=1;
   for (p=0; p<strlen(u.name); p++) {
     if (f) {
       if ((u.name[p]>='A') && (u.name[p]<='Z'))
         f=0;
       o[p]=u.name[p];
     } else {
       if ((u.name[p]>='A') && (u.name[p]<='Z'))
         o[p]=u.name[p]-'A'+'a';
       else {
         if ((u.name[p]>=' ') && (u.name[p]<='/') && (!(u.name[p]==39))
             && (!(u.name[p]==40)))
           f=1;
         o[p]=u.name[p];
       }
     }
   }
   o[p]=0;
   return(o);
}

[Save UTILITY.C]

[Step 5]   MAKE FCNS or add the marked line to FCNS.H

= char *nam(userrec *u1, unsigned int un);
= char *nam1(userrec *u1, unsigned int un, unsigned int sy);
+ char *nam2(userrec *u1);
= double nsl(void);

[Step 6]   Recompile!


        You might have to do a //RESETF from inside your board to get it to
    recognize the city and state that your user list now uses.  Enjoy!

    If you use this mod, please send me some E-Mail at 1@8307 (WWIVnet) and
    tell me how you like it!

Dream World BBS * (803)749-3171 * WWIV v4.21a * WWIVnet 1@8307 * Advent 1@8307 
                           Auto-SysOp Validation 



