Ŀ
 Mod Name    : XLAN005F.MOD               Mod Author: 1@9443 [WWIVnet]      
 Version     : 1.5                        Mod Date  : 3/7/93                
 Difficulty  : Easy, if you pay attention.                                  
 WWIV Version: 4.2x <-------------------                                    
 Description : A title scan mod that displays user name and post titles in  
               color and strips existing color codes from name/title info,  
               displaying a full screen of twenty titles at a time.         
 Warranty    : Tech Support Hotline Open 3:17am to 3:18am Every Leap Year   
               Also, back up your source!                                   


This is a variation on the XLAN005D title scan mod. 

An omission in the step by step instructions has been corrected, a minor
glitch in the "Y" case has been fixed, and the strip color function has
been changed.

XLAN005E & XLAN005F now add a "More? [CR/R/Y/N/Q/#/?]:" prompt at the end
of each screenfull.

Hitting RETURN, "Y", "T", or "S" will display another screenfull of titles.
"R" will read the next message number after the current list. 
"?" will display a mini-menu of command options. 
"N" for No will quit to the primary msg reading prompt. 
"#" means you can enter a message number and read that message. 
"Q" for Quit will quit to the main menu prompt.  

This version replaces version XLAN005D. 

---------------------------------------------------------------------------

There have been numerous title scan mods produced, all drawing from
similar sources. I previously released a title scan mod of my own,
which was itself derived from an older mod by Bruce Gutherie. Darrell
Mobley modded my mod, then I modded his mod of my mod, and the
variations continue to pop up, as we all have the same idea, and keep
trying to perfect it in various ways. I am sure there are countless
other mods that do similar things out there, and don't mean to imply
the folks cited above are the only ones who have ever produced mods of
this type.

The most recent title scan mod I have seen is from Frank Reid, #1 @870,
who added Tolkien's "first" and "strip_wwiv" functions. I liked this
mod, but it seemed overly complicated, and required adding to vars.h,
and recompiling the whole system. 

Frank's mod used Tolkien's functions to produce evenly spaced columns,
even when the columns had embedded color codes, and to make sure the
color intended by the sysop for the columns overrode the colors that
might have existed in the name/title fields of the original message. My
previous versions had sometimes had difficulty maintaining column width
with titles that had embedded color codes.

I pulled out the two lines that called Tolkien's functions, and the two
functions themselves, and used them in my existing mod, where they
worked as intended, and produced a much better version of the mod.

I do not promote this title scan mod as better or worse than anyone
else's, but it works as advertised, and has proven to be fairly bullet
proof on my own system.


/********************************************************************/
In MSGBASE1.C locate "void scan(int msgnum, int optype, int *nextsub)"

And add the following:

=  void scan(int msgnum, int optype, int *nextsub)
=  {
=    char s[81],s1[81],s2[81],*b,*ss1;
=    int i,i1,i2,done,quit,abort,next,val,realexpress;
=    slrec ss;
=    long l,len;
=    postrec p,p1;
+    userrec u;        /* add this line */

/********************************************************************/


/********************************************************************/
In MSGBASE1.C, locate and delete the entire "case 1: /* List Titles */"
segment, and block copy the following code in its place. Make sure you do
not get carried away and delete any of "case 2:", just afterward.
/*******************************************************************/

     case 1: /* BEGIN XLAN005F LIST TITLES MOD */
       i=0;
       abort=0;
       outchr(12);
       pla("
",&abort);

       if (msgnum>=nummsgs)
       abort=1;
       while ((!abort) && (!hangup) && (++i<=20)) {
       ++msgnum;

       if (msgs[msgnum].qscan>qsc_p[curlsub])
       strcpy(s,"* ");
       else
       strcpy(s,"- ");

       itoa(msgnum,s2,10);

       if ((msgs[msgnum].ownersys==0) && (msgs[msgnum].owneruser==usernum))
       sprintf(s1,"%s%3.3s ",s,s2);
       else
       sprintf(s1,"%s%3.3s ",s,s2);
       outstr(s1);
       ss=syscfg.sl[thisuser.sl];
       if ((msgs[msgnum].anony & anony_sender) && 
          ((ss.ability & ability_read_post_anony)==0)) {
       sprintf(s,"-=> UNKNOWN <=-");
       outstr(s);
      }
       if (msgs[msgnum].ownersys==0) {
       read_user(msgs[msgnum].owneruser,&u);
       sprintf(s,"%-31.31s",
       (first(31,(strip_wwiv(nam(&u,msgs[msgnum].owneruser))))));
       outstr(s);
      }
       if (msgs[msgnum].ownersys>=1) {
       grab_user_name(&(msgs[msgnum].msg),subboards[curlsub].filename);
       sprintf(s,"%-31.31s",(first(31,(strip_wwiv(net_email_name)))));
       outstr(s);
      }
       if (wherex()>38) {
       backspace();
      }
       outstr(" ");
       sprintf(s," %-37.37s",
              (first(37,(strip_wwiv(msgs[msgnum].title)))));
       pla(s,&abort);

       if (msgnum>=nummsgs) 
       abort=1;
       if (abort==1)
       pl("\r
");
       optype=3;
     }
       pla("
",&abort);
       optype=3;
       break;       

/*********************************************/

      case 3: 
        nl();
        prt(2,"More? [CR/R/Y/N/Q/#/?]: ");
        input(s,3);
        while (s[0]==32) {
        strcpy(s1,&(s[1]));
        strcpy(s,s1);
      }
        optype=3; 
        i=atoi(s);
 
        if (s[0]==0) {
        optype=1;
        if (msgnum==nummsgs) 
        done=1;
        if (i>=nummsgs+1)
        done=1;
      }
        if ((i!=0) && (i<=nummsgs) && (i>=1)) {
        optype=2;
        msgnum=i;
      } else
        if (s[1]==0) {
        switch(s[0]) {
         case 'T':
         case 'Y':
           optype=1;
           if (msgnum==nummsgs) 
           done=1;
           if (i>=nummsgs+1)
           done=1;
           break;
         case 'N':
           optype=0;
           break;
         case 'R':
           optype=2;
           break;
         case '?':
           nl();
		 pl("         CR = RETURN & Read More Titles | Y, T or S = Read More Titles         ");
		 pl("               R = Read Next Message | N = Return To Msg Prompt                ");
		 pl("           # = Enter Message Number |  Q = Quit To Main Menu Prompt            ");
		 nl();
		 break;
	    case '#':
           nl();
           pl("Read A Message By Entering Its Number -- For Example: '12'");
           nl();
           break;
         case 'Q':
           quit=1;
           done=1;
           *nextsub=0;
           break;
         }
        }
           break;     /* END XLAN005F MOD */

/*******************************************************************/
At the end of MSGBASE1.C, block copy in the folowing two voids.
/*******************************************************************/

unsigned char *first(int len, char *ss)
{
  static char s[81];

  strcpy(s,ss);
  if (strlen(s)<=len)
    return(s);
  s[len]=0;
  return(s);
}

unsigned char *strip_wwiv(char *instr)
{
  static unsigned char s[161];
  char c;
  int i,i1;

   if (strlen(instr)==0)
   return("");

   i=0; i1=0;
   do {
   c=instr[i];
   if (c==3)
   i++;
   else
   if ((c!=1) && (c!=2) && (c!=4) && (c!=6)) {
   s[i1]=c;
   i1++;
 }
   i++;
 } while (i<strlen(instr));
   s[i1]=0;
   return(s);
}

/********************************************************************/
Make FCNS.H
Re-Compile. Good-Luck!
/********************************************************************/


 Life Arts Network BBS Ŀ
    Host: GateOpsNet -- The MultiNet Sysop Sub! | Type: GATOP              
 WWIVnet @9443  WWIVlink @19443  ICEnet @9443 

